//
//  PRBaseConfig.h
//  PRiphone
//
//  Created by Jackie Cane on 7/5/12.
//  Copyright (c) 2012 NewspaperDirect. All rights reserved.
//

#import <PRConfiguration/PRUserDefaults.h>

#pragma mark - Standard Defaults Accessors

#define STANDARD_DEFAULTS (PRUserDefaults.standardUserDefaults)

#define _PRCONFIG_BOOL_(ARG, DEFAULT_VALUE)	PR_DEFAULTS_BOOL_(STANDARD_DEFAULTS, ARG, DEFAULT_VALUE)
#define _PRCONFIG_BOOL_SET_(ARG, VALUE) PR_DEFAULTS_BOOL_SET_(STANDARD_DEFAULTS, ARG, VALUE)

#define _PRCONFIG_INT_(ARG, DEFAULT_VALUE)	PR_DEFAULTS_INT_(STANDARD_DEFAULTS, ARG, DEFAULT_VALUE)
#define _PRCONFIG_INT_SET_(ARG, VALUE) PR_DEFAULTS_INT_SET_(STANDARD_DEFAULTS, ARG, VALUE)

#define _PRCONFIG_DOUBLE_(ARG, DEFAULT_VALUE)	PR_DEFAULTS_DOUBLE_(STANDARD_DEFAULTS, ARG, DEFAULT_VALUE)
#define _PRCONFIG_DOUBLE_SET_(ARG, VALUE) PR_DEFAULTS_DOUBLE_SET_(STANDARD_DEFAULTS, ARG, VALUE)

#define _PRCONFIG_STRING_(ARG, DEFAULT_VALUE)    PR_DEFAULTS_STRING_(STANDARD_DEFAULTS, ARG, DEFAULT_VALUE)
#define _PRCONFIG_STRING_SET_(ARG, VALUE) PR_DEFAULTS_STRING_SET_(STANDARD_DEFAULTS, ARG, VALUE)
#define _PRCONFIG_STRING_SET_NONNULL_(ARG, VALUE) PR_DEFAULTS_STRING_SET_NONNULL_(STANDARD_DEFAULTS, ARG, VALUE)

#define _PRCONFIG_OBJ_(ARG, DEFAULT_VALUE)    PR_DEFAULTS_OBJ_(STANDARD_DEFAULTS, ARG, DEFAULT_VALUE)
#define _PRCONFIG_OBJ_SET_(ARG, VALUE) PR_DEFAULTS_OBJ_SET_(STANDARD_DEFAULTS, ARG, VALUE)

#pragma mark - General Defaults Accessors

#define PR_DEFAULTS_BOOL_(DDB, ARG, DEFAULT_VALUE)  ([DDB objectForKey:ARG] != nil ? [DDB boolForKey:ARG] : DEFAULT_VALUE)
#define PR_DEFAULTS_BOOL_SET_(DDB, ARG, VALUE) [DDB setBool:VALUE forKey:ARG]

#define PR_DEFAULTS_INT_(DDB, ARG, DEFAULT_VALUE)  ([DDB objectForKey:ARG] != nil ? [DDB integerForKey:ARG] : DEFAULT_VALUE)
#define PR_DEFAULTS_INT_SET_(DDB, ARG, VALUE) [DDB setInteger:VALUE forKey:ARG]

#define PR_DEFAULTS_DOUBLE_(DDB, ARG, DEFAULT_VALUE)  ([DDB objectForKey:ARG] != nil ? [DDB doubleForKey:ARG] : DEFAULT_VALUE)
#define PR_DEFAULTS_DOUBLE_SET_(DDB, ARG, VALUE) [DDB setDouble:VALUE forKey:ARG]

#define PR_DEFAULTS_STRING_(DDB, ARG, DEFAULT_VALUE)  ([DDB objectForKey:ARG] != nil ? [DDB stringForKey:ARG] : DEFAULT_VALUE)
#define PR_DEFAULTS_STRING_SET_(DDB, ARG, VALUE) [DDB setObject:VALUE forKey:ARG]
#define PR_DEFAULTS_STRING_SET_NONNULL_(DDB, ARG, VALUE) ([VALUE length] ? [DDB setObject:VALUE forKey:ARG] : nil)

#define PR_DEFAULTS_OBJ_(DDB, ARG, DEFAULT_VALUE)  [DDB objectForKey:ARG] ? : DEFAULT_VALUE
#define PR_DEFAULTS_OBJ_SET_(DDB, ARG, VALUE) [DDB setObject:VALUE forKey:ARG]

#pragma mark - Utils

#if defined USING_CHAMELEON || defined __IPHONE_OS_VERSION_MAX_ALLOWED
#define PR_IOS
#else
#define PR_MACOS
#endif

#ifdef DEBUG
#define IS_DEBUG 1
#else
#define IS_DEBUG 0
#endif
